Copying an issue fails if the issue is watched by a locked user

2018-05-14 07:32 - Ayami Yasuoka

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 3.4.6   

Resolution: Fixed Affected version:  

Description

When copying the parent issue having child issue, some issues could not be copied.

The "Copy subtasks" checkbox is checked.

After checking the log, it turned out that only the issue for which the member of the lock account is set to the watcher has not been

copied.

Even if the members of the lock account are set on the watcher, I want you to be able to copy the issue.

Redmine 3.4.2

rudy version:2.3.3-p222

Rails 4.2.8

I will post it for the first time. I'm sorry if I made a mistake in my way.

Related issues:

Related to Redmine - Defect #27863: If version is closed or locked  subtasks ... Closed

Associated revisions

Revision 17342 - 2018-05-19 02:44 - Go MAEDA

Fix: Copying an issue fails if the issue is watched by a locked user (#28765).

Patch by Marius BALTEANU.

Revision 17343 - 2018-05-19 03:31 - Go MAEDA

Merged r17342 from trunk to 3.4-stable (#28765).

History

#1 - 2018-05-14 10:18 - Go MAEDA

- Tracker changed from Feature to Defect

- Subject changed from Issue copy can not be done if lock account member is set on watcher to Copying an issue fails if the issue is watched by a

locked user

- Category set to Issues

I confirmed the problem. Copying an issue fails if the issue is watched by a locked user and a validation error "Watchers is invalid" is displayed.

I will post it for the first time. I'm sorry if I made a mistake in my way.

 There was no problem at all. Thank you for reporting this issue.

#2 - 2018-05-14 10:19 - Go MAEDA

- Status changed from New to Confirmed

#3 - 2018-05-14 10:21 - Go MAEDA

- Related to Defect #27863: If version is closed or locked  subtasks don't get copied  added

#4 - 2018-05-14 23:33 - Marius BĂLTEANU

- File 0001-do-not-propose-locked-watchers-when-copying-an-issue.patch added
- Target version set to Candidate for next minor release

Attached is a patch with a test included that fixes this issue.  I chose to propose in the UI only active users as watchers when copying an issue.

#5 - 2018-05-15 04:57 - Go MAEDA

- Assignee set to Marius BĂLTEANU

Thank you for working on this issue, Marius. I confirmed that the patch fixes the problem.

But I noticed that inactive users should be excluded not only in the UI but also in Issue#copy_from method because there still be a problem even after

applying the patch. Issues which have locked watchers are not copied when admins use project copy feature.

What do you think including the following code in your patch?

Index: app/models/issue.rb

===================================================================

--- app/models/issue.rb    (revision 17329)

+++ app/models/issue.rb    (working copy)

@@ -274,7 +274,8 @@

       end

     end

     unless options[:watchers] == false

-      self.watcher_user_ids = issue.watcher_user_ids.dup

+      self.watcher_user_ids =

+        issue.watcher_users.select{|u| u.status == User::STATUS_ACTIVE}.map(&:id)

     end

     @copied_from = issue

     @copy_options = options

#6 - 2018-05-15 09:04 - Marius BĂLTEANU

- File 0001-unit-test-for-locked-watchers.patch added

- Assignee changed from Marius BĂLTEANU to Go MAEDA

Oh, I didn't think to this case, thanks for finding it.

It looks good and I made a unit test also for this scenario (attached).

#7 - 2018-05-15 10:23 - Go MAEDA

- Assignee deleted (Go MAEDA)

- Target version changed from Candidate for next minor release to 3.4.6

Marius BALTEANU wrote:

It looks good and I made a unit test also for this scenario (attached).

 Great, the patch looks perfect now. I am setting target version to 3.4.6. The patches to be committed are as follows:

0001-do-not-propose-locked-watchers-when-copying-an-issue.patch

#28765#note-5

0001-unit-test-for-locked-watchers.patch

#8 - 2018-05-15 14:41 - Andreas Deininger

- File 0001-unit-test-for-locked-watchers_corrected.patch added

In the unit test patch, the name of the test method is misspelled. This typo is fixed in the attached patch.

#9 - 2018-05-16 03:42 - Go MAEDA

Andreas Deininger wrote:

In the unit test patch, the name of the test method is misspelled. This typo is fixed in the attached patch.

 Thank you for pointing out that "shoud" should be "should".

2025-07-04 2/3

https://www.redmine.org/attachments/20660
https://www.redmine.org/issues/28765#note-5
https://www.redmine.org/attachments/20668


#10 - 2018-05-19 02:46 - Go MAEDA

- Status changed from Confirmed to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

#11 - 2018-05-19 03:32 - Go MAEDA

- Status changed from Resolved to Closed

Committed to the trunk and 3.4-stable branch. Thank you all for reporting and fixing this issue.

Files

0001-do-not-propose-locked-watchers-when-copying-an-issue.patch 2.34 KB 2018-05-14 Marius BĂLTEANU

0001-unit-test-for-locked-watchers.patch 1.19 KB 2018-05-15 Marius BĂLTEANU

0001-unit-test-for-locked-watchers_corrected.patch 1.19 KB 2018-05-15 Andreas Deininger
